package com.emsoft.grails

import nl.captcha.Captcha
import nl.captcha.servlet.CaptchaServletUtil

class CaptchaHelper {

    static void renderCaptcha(int width, int height, boolean background = true,
            boolean border = true, int noiseCount = 2) {
        def builder = new Captcha.Builder(width, height).addText()
        if (background)
            builder.addBackground()
        if (border)
            builder.addBorder()
        noiseCount.times {
            builder.addNoise()
        }
        def captcha = builder.build()
        CaptchaServletUtil.writeImage(GrailsHelper.response, captcha.image)
        GrailsHelper.session.setAttribute(Captcha.NAME, captcha)
    }

    static Captcha getCaptcha() {
        GrailsHelper.session.getAttribute(Captcha.NAME) as Captcha
    }

    static void clearCaptcha() {
        GrailsHelper.session.removeAttribute(Captcha.NAME)
    }

    static boolean validateCaptcha(String answer) {
        def ok = captcha && captcha.isCorrect(answer)
        if (ok)
            clearCaptcha()
        return ok
    }
}
