package com.emsoft.grails

import javax.imageio.ImageIO
import javax.servlet.http.HttpServletResponse
import org.codehaus.groovy.grails.web.servlet.mvc.GrailsWebRequest

class RenderHelper {

    /**
     * @param data File, InputStream, URL, ImageInputStream or byte array
     * @param imageFormat
     * @return
     */
    static HttpServletResponse renderImage(data, String imageFormat = "png") {
        def response = GrailsHelper.response
        if (data) {
            response.setHeader("Cache-Control", "private,no-cache,no-store")
            response.contentType = "image/$imageFormat"
            if (data instanceof byte[])
                data = new ByteArrayInputStream(data)
            def stream = response.outputStream
            try {
                ImageIO.write(ImageIO.read(data), imageFormat, stream)
            }
            catch (ex) {
                ex.printStackTrace()
            }
            finally {
                stream.close()
            }
        }
        return response
    }

    /**
     * @param markup gsp code of template to render
     * @return
     */
    static GrailsWebRequest renderTemplate(String markup) {
        def webReq = GrailsHelper.webRequest
        GrailsHelper.createTemplate(markup).writeTo(webReq.out)
        return webReq
    }
}
